const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const usage_limits = sequelize.define(
    'usage_limits',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

feature: {
        type: DataTypes.ENUM,
      
      

        values: [

"career_coach",


"ai_tutor",


"roadblock_bot"

        ],

      },

limit_count: {
        type: DataTypes.INTEGER,
      
      

      },

used_count: {
        type: DataTypes.INTEGER,
      
      

      },

window_start_at: {
        type: DataTypes.DATE,
      
      

      },

window_end_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  usage_limits.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

































//end loop



    db.usage_limits.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.usage_limits.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.usage_limits.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.usage_limits.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return usage_limits;
};


